#!/usr/bin/python
#
mx = 'lcs.mit.edu'
mx = 'r3.simson.net'

import getopt,sys
import email.Utils
import re,os
import time

def usage():
    print "usage: %s -k <keyfile> -c <certfile> -t <to-email> "
    print "           -m <message> -p <template> -o <oldsn> -s <subject>"
    print "           -r <reply-to> -e <extra-options>"
    print "           -# count  -z (turn off copilot) -Z (don't sign and warn)"
    print "           -g <cc>"


def html_quote(s):
    return s.replace("<","&lt;").replace(">","&gt;")

import smtplib;
if __name__ == "__main__":

    try:
        opts,args = getopt.getopt(sys.argv[1:],'hk:c:t:m:p:o:s:#:r:g:e:zZ',['help'])
    except getopt.GetoptError:
        print usage
        sys.exit(2)

    subject = ''
    oldsn   = ''
    count   = 'an unknown number'
    reply_to = ''
    cc      = ''
    extra   = ""
    sleeptime = 0
    cc_list = ''
    dont_sign = False
    dir = "/Users/simsong/mit/johnny2/" 
    for o,a in opts:
        if o in ('-h'):
            usage()
            sys.exit(2)
        if o in ('-k'):
            keyfile = a
        if o in ('-c'):
            certfile = a
        if o in ('-t'):
            to_email = a
        if o in ('-m'):
            message = open(dir+a,"r").read()
        if o in ('-p'):
            template = open(dir+a,"r").read()
        if o in ('-o'):
            oldsn = a
        if o in ('-s'):
            subject = a
        if o in ('-#'):
            count   = a
        if o in ('-r'):
            reply_to = a
	if o in ('-g'):
	    cc += "cc: " + a + "\n"
            if(len(cc_list)>0):
                cc_list += ", "
            cc_list += a
	if o in ('-e'):
            extra += a + " "
        if o in ('-z'):
	    #dont_sign = True
            template = open(dir+"template_none.html","r").read()
        if o in ('-Z'):
            dont_sign = True


    # Now substitute < and > in to-email

    from_email = os.popen("openssl x509 -email -in %s -noout" % certfile).read().strip()
    from_email_only = from_email

    x509_subject = os.popen("openssl x509 -subject -in %s -noout" % certfile).read().strip()
    m = re.search("/CN=([a-zA-Z .']+)",x509_subject)
    if(m):
        from_email = m.group(1) + " <" + from_email + ">"
    x509_serial = os.popen("openssl x509 -serial -in %s -noout" % certfile).read().replace("serial=","").strip()


    # Turn cc_list into proper HTML
    cc_list = cc_list.replace("<","&lt;").replace(">","&gt;")

    # Now substitute the template
    msg = template.replace("$MESSAGE",message)
    msg = msg.replace("$QTO",html_quote(to_email))
    msg = msg.replace("$TO",to_email)
    msg = msg.replace("$QFROM",html_quote(from_email))
    msg = msg.replace("$FROM",from_email)
    msg = msg.replace("$SUBJECT",subject)
    msg = msg.replace("$SN",x509_serial)
    msg = msg.replace("$QCC",cc_list)
    if(count==1):
        msg = msg.replace("$COUNTPLURAL","")
    else:
        msg = msg.replace("$COUNTPLURAL","s")
    msg = msg.replace("$COUNT",count)
    msg = msg.replace("$SO",oldsn)

    # Now create the signed message
    f = open("tempfile.txt","w")
    f.write(msg)
    f.close()

    signed_message  = "Date: " + email.Utils.formatdate() + "\n"
    if(reply_to != ''):
        signed_message += "Reply-to: " + reply_to + "\n"
    if(cc != ''):
        signed_message += cc

    if(dont_sign==False):
        signed_message += os.popen("openssl smime -from '%s' -to '%s' -subject '%s' -sign -inkey %s -signer %s -in tempfile.txt extra"
                                   % (from_email,to_email,subject,keyfile,certfile)).read()
    else:
        signed_message += "From: " + from_email + "\n" + \
                          "To: " + to_email + "\n" + \
                          "Subject: " + subject + "\n" + \
                          msg
    

    server = smtplib.SMTP(mx)
    server.sendmail(from_email_only,to_email,signed_message)
    os.unlink("tempfile.txt")
    
    
    
